# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""
from enum import Enum

"""Wyniki kontroli"""

class Type(Enum):
    """Rodzaj wyniku kontroli"""
    CONTROL=1
    WARNING=0

class TypeOfControl(Enum):
    """Typ kontroli"""
    DATA=1
    GEOMETRIC=2
    DESCRIPTION=3
    NONE=0

class Result():
    """"Wynik kontroli"""
    
    def __init__(self,name:str,message:str,errors,type_of_control:TypeOfControl,type=Type.CONTROL):
        self.type=type
        self.name=name
        #Nazwa kontroli
        self.message=message
        #Komunikat
        self.errors=errors
        #Błędy
        self.type_of_control=type_of_control
    

    @property
    def result(self):
        """Rezultat kontroli"""
        if self.errors is not None:
            if len(self.errors)>0:
                return False
        return True

    @property
    def type_str(self):
        """Tekst typu kontroli"""
        types={
            Type.WARNING:'Ostrzeżenie',
            Type.CONTROL:'Błąd'
            }
        return types.get(self.type,'Brak typu')
        
        
class WynikKontroli(object):
    """Wynik kontroli danych"""
    #Marcin Śliwa
    def __init__(self,nazwa,komunikat_baza,komunikat_warstwa,*nazwaWarstwy):
        """konstruktor"""
        self.__nazwa=nazwa
        self.__nazwaWarstwy=[]
        for nw in nazwaWarstwy:
            self.__nazwaWarstwy.append(nw)
        self.__warstwa=[]
        self.__baza=[]
        self.__wynik=True
        self.__komunikat_baza=komunikat_baza
        self.__komunikat_warstwa=komunikat_warstwa
        self.__results=[]
        #Należy to wywalić po wyczyszczeniu klasy, jest wprowadozne żeby zawierać błędy geometryczne stare przed przebudową
        self.bledy_geom=[]
        
    @property
    def bledyWarstwy(self):
        """błedy warstwy"""
        return self.__warstwa
    
    @bledyWarstwy.setter
    def bledyWarstwy(self,wartosc):
        self.__warstwa=wartosc
    
    @bledyWarstwy.getter
    def bledyWarstwy(self):
        return self.__warstwa
    
    @property
    def bledyBazy(self):
        """błedy bazy"""
        return self.__baza
        
    
    @bledyBazy.setter
    def bledyBazy(self,wartosc):
        self.__baza=wartosc    
    
    @bledyBazy.getter
    def bledyBazy(self):
        return self.__baza
    
    @property
    def nazwa(self):
        """nazwa kontroli"""
        return self.__nazwa
    
    @nazwa.getter
    def nazwa(self):
        return self.__nazwa
    
    @property
    def nazwaWarstwy(self):
        """nazwa warstwy"""
        return self.__nazwaWarstwy
    
    @nazwaWarstwy.getter
    def nazwaWarstwy(self):
        return ','.join(self.__nazwaWarstwy)
    
    @property
    def wynik(self):
        """wynik kontroli"""
        return self.__wynik
    
    @wynik.getter
    def wynik(self):
        if len(self.__baza)>0 or len(self.__warstwa)>0:
            return False
        return True
    
    @property
    def komunikatBaza(self):
        """komunikat dla błędu bazy danych wykorzystywany w raporcie błędów"""
        return self.__komunikat_baza
    @komunikatBaza.getter
    def komunikatBaza(self):
        """komunikat dla błędu bazy danych wykorzystywany w raporcie błędów"""
        return self.__komunikat_baza
    
    @property
    def komunikatWarstwa(self):
        """komunikat dlabłędu warstwy wykorzystywany w raporcie błędów"""
        return self.__komunikat_warstwa
    @komunikatWarstwa.getter
    def komunikatWarstwa(self):
        """komunikat dlabłędu warstwy wykorzystywany w raporcie błędów"""
        return self.__komunikat_warstwa
    
    def add_result(self,result:Result):
        """Dodanie wyniku kontroli"""
        self.__results.append(result)
        
    @property
    def results(self):
        """Wyniki kontroli"""
        return self.__results
    
    
    
